CPU 386
;;ORG 100h
section .text
[BITS 16]
real_to_protect:
	pushad
	sgdt	[cs:sGDT]
;;;	out	50h,al	;//PC-98 nmi disable
	call	call_pmode
	lgdt	[cs:sGDT]
;;;	out	52h,al	;//PC-98 nmi enable
	popad
	retf	;あえてretfだ!

call_pmode:
	push	ds
	push	es
	push	fs
	push	gs

	xor	ebx,ebx
	xor	edx,edx
	mov	dx,GDT
	mov	[cs:GDT_p+2],edx
	mov	bx,cs		;csMAX=0xffff
	mov	[cs:CODE_SEGMENT],bx
	shl	ebx,4
	add	[cs:GDT_p+2],ebx
	and	ebx,0x00ffffff	;max=0xffff0だけど一応

	test	byte [cs:GDT_CS+5],1
	jnz	alreadysettings

	add	[cs:GDT_CS+2],ebx	;ebxは20bit以下のはず!!! 仮想86でも???
	add	[cs:GDT_CS16+2],ebx	;ebxは20bit以下のはず!!! 仮想86でも???
	add	[cs:GDT_DS16CS+2],ebx	;ebxは20bit以下のはず!!! 仮想86でも???
	or	byte [cs:GDT_CS+5],1 ;checker
alreadysettings:
	mov	cx,ss
	mov	[cs:SS0],cx

;;	pushfd
;;	pop	eax
;;	and	eax,~0x20000	;仮想86やめ 無意味
;;	push	eax
;;	popfd

	lgdt	[cs:GDT_p]

	mov	eax,cr0
	mov	[cs:CPUCR0],eax
	or	al,1		;protected mode
;;//	and	eax,7fffffffh	;non paged
	mov	cr0,eax
	jmp	$+2

	push	20h		;;CS16 CPL=0
	push	pmode_entry	;;qemu9821ではflagが厳しい 突入できないフラグがある
	retf			;;np21ではジャンプでも入れるしretfでも入れる
pmode_entry:
	movzx	ebp,sp
;;	mov	ax,ss
;;	movzx	eax,ax
;;	shl	eax,4
;;	add	esp,eax	;ss:sp -> esp

	movzx	esi,si
	mov	ax,ds
	movzx	eax,ax
	shl	eax,4
	add	esi,eax	;ds:si -> esi

	movzx	edi,di
	mov	ax,es
	movzx	eax,ax
	shl	eax,4
	add	edi,eax	;es:si -> edi

	mov	ax,10h
	mov	ds,ax		;ds=selector10h GDT_DS	base=0 limit4GB
	mov	es,ax		;es=selector10h GDT_DS	base=0 limit4GB
	mov	ax,38h
	mov	fs,ax		;fs=selector38h GDT_DS	base=0 limit=0xfffff(1MB)	
	mov	ax,30h
	mov	gs,ax		;gs=selector30h GDT_DS16CS base=CS limit=64k
	mov	ss,ax		;gs=selector30h GDT_DS16CS
	mov	sp,localstack

	push	ebp
	call	originalcommand
	pop	ebp

	mov	ax,18h
;;	mov	ss,ax		;ss=selector18h GDT_SS limit=0xffff(64kB)あかん!!!
	mov	ds,ax		;ds=selector18h GDT_SS
	mov	es,ax		;es=selector18h GDT_SS
	mov	fs,ax		;fs=selector18h GDT_SS
;//	mov	gs,ax		;gs=selector18h GDT_SS

;;	db	0eah
;;	dd	flush
;;	dd	20h		;CS16に戻っておかないと qemuでは32bitアクセス続けちゃう

;;	push	20h		;CS16 CPL=0
;;	push	flush
;;	retf
;;flush:
	mov	eax,[cs:CPUCR0]
	mov	cr0,eax
	jmp	$+2

	mov	ax,[GS:CODE_SEGMENT]
	push	ax
	push	return_from_pmode
	retf

CODE_SEGMENT:	dd	0
return_from_pmode:
	mov	bx,[CS:SS0]
	mov	ss,bx
	mov	sp,bp
	pop	gs
	pop	fs
	pop	es
	pop	ds
	ret

CPUCR0:dd	0
SS0:	dw	0
GDT:
GDT_NULL:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0		;access byte
		db	-1		;limit 0xff0000
		db	0		;flags & base =0

GDT_CS:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0x9a		;access byte writable direction0 execute descripter1 DPL=0 present 
		db	0xc0		;flags granularity1 size=32bit
		db	0		;base 24-31

GDT_DS:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0x0		;base 16-23
		db	0x92		;access byte readable direction0 descripter1 DPL=0 present 
		db	0xc0|0xf	;flags granularity1 size=32bit
		db	0		;base 24-31

GDT_SS:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0x92		;access byte readable direction0 descripter1 DPL=0 present 
		db	0		;flags granularity0 size=16bit
		db	0		;base 24-31


GDT_CS16:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0x9a		;access byte writable direction0 execute descripter1 DPL=0 present 
		db	0		;flags granularity0 size=16bit
		db	0		;base 24-31

GDT_DS16:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0xF0		;base 16-23
		db	0x92		;access byte writable direction0 descripter1 DPL=0 present 
		db	0		;flags granularity0 size=16bit
		db	0		;base 24-31
GDT_DS16CS:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0x0		;base 16-23
		db	0x92		;access byte writable direction0 descripter1 DPL=0 present 
		db	0		;flags granularity0 size=16bit
		db	0		;base 24-31
GDT_DS16_1M:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0x92		;access byte readable direction0 descripter1 DPL=0 present 
		db	0xf		;flags granularity0 size=16bit limit |= 0xf0000
		db	0		;base 24-31
GDT_ES16_64k:	dw	-1		;limit=0xffff
		dw	0		;base 0-15
		db	0		;base 16-23
		db	0x92		;access byte readable direction0 descripter1 DPL=0 present 
		db	0		;flags granularity0 size=16bit
		db	0		;base 24-31
	times 120	db 0
localstack:

sGDT:
dw	0
dd	0
GDT_p:
dw	71	;size-1
dd	GDT	;address(physical)
