;参考文献
;https://hp.vector.co.jp/authors/VA003988/asm.htm
;intelの公式資料に中っていません。その状態のプログラムであることに注意

CPU 8086
ORG	100h
section .text
	push	cs
	pop	ds


	cli				;割り込みとめなきゃ危ないってことか?
	pushf
	push	ax

	mov	ax,7000h
	push	ax
	popf
	pushf
	pop	ax
	sti				;ここまで来たらもどしてもいいでしょ?

	and	ax,0f000h
	cmp	ax,0
	je	calc286		;0なら286リアルモード	条件ジャンプが遠いとアセンブラは286命令使わなくなりますよ 気をつけましょうね
	cmp	ax,0f000h
	je	calcv30		;0f000hなら8086orV30

CPU 586
	or	byte [cs:CPUfamily],2	;32bitCPU

	pushfd
	push	eax
	push	ebx
	pushfd
	pop	eax
	mov	ebx,eax
	xor	eax,1<<21	;;able to use CPUID instruction
	push	eax
	popfd
	pushfd
	pop	eax
	xor	eax,ebx
	pop	ebx
	pop	eax
	je	nocpuid
	popfd

	mov	eax,1
	cpuid
	test	edx,1<<4	;time stamp counter enable
	je	calc286

	or	byte [cs:CPUfamily],8	;rdtsc
	mov	dx,2
	in	al,dx
	test	al,1		;IR0割り込みを許可中かの確認
	jne	timerOK
	or	byte [cs:timerNG],1
timerOK:
	cli			;割り込み禁止しなきゃ
	call	pitready
	call	pitcount
	mov	[c16],ax
	rdtsc
	mov	[c64],eax
	mov	[c64+4],edx
	call	artic
	mov	[c24],eax
	mov	eax,15		;mili seconds order max 54600ms under 16bit  でも8253は26msしか測れない
	call	articwait
;TSC持ち機種はPentium機 そいつらは307.2kHzの24bitカウンタは持ってる
	call	pitcount
	mov	[C16],ax
	rdtsc
	mov	[C64],eax
	mov	[C64+4],edx
	call	artic
	mov	[C24],eax
	sti			;計測終わったら構わないよ

	mov	edx,[C64+4]
	mov	eax,[C64]
	mov	edi,[c64+4]
	mov	esi,[c64]
	sub	eax,esi	;128bitのカウンタは絶対一回りしてないとおもうけど 回ってたらどうしよ…
	sbb	edx,edi	;tscでの進行カウント数	edx:esi


	test	byte [cs:timerNG],1
	je	timer8253	;使ってなければ8253へ行く ARTICは補助

	mov	edi,[c24]
	mov	ecx,[C24]
	cmp	ecx,edi
	ja	nocarry
	add	ecx,1000000h
nocarry:
	sub	ecx,edi	;経過時間カウント 307.2kHz(3.26us)
	div	ecx		;割り算をすると3.26usあたりのCPUクロック MHz(1usあたりのクロック)になおしたいから
				;さらに3.26で割りたいし10進数にも直したい あー邪魔くさい
	mov	ecx,1000000
	mul	ecx		;1000000倍する
	mov	ecx,32552	;32552で割る
	div	ecx		;

calculate:
	cmp	eax,1000*100	;1000*100MHz 1GHz以上なら飛ぶ bug 10000hではない
	ja	over16
CPU 8086
under16:
	call	hex_to_dec
	mov	si,MHz2
	call	ascii_to_sjis
	add	si,2
	mov	al,bh
	call	ascii_to_sjis
	add	si,3
	mov	al,bl
	call	ascii_to_sjis


	mov	al,30h
	mov	ah,20h
	cmp	[MHz2],al
	jne	Print4
	mov	[MHz2],ah
	cmp	[MHz2+1],al
	jne	Print4
	mov	[MHz2+1],ah
	cmp	[MHz2+2],al
	jne	Print4
	mov	[MHz2+2],ah
	cmp	[MHz2+3],al
	jne	Print4
	mov	[MHz2+3],ah
	cmp	[MHz2+4],al
	jne	Print4
	mov	[MHz2+4],ah
	jmp	Print4
Print2:
	mov	dx,CPU586
	mov	ah,9
	int	21h
	mov	dx,print
	mov	ah,9
	int	21h
	mov	ah,4ch
	int	21h

CPU 386
over16:
	mov	ecx,100
	xor	edx,edx		;edxにしとかなきゃ!
	div	ecx
CPU 8086
	call	hex_to_dec
	mov	si,MHz3
	call	ascii_to_sjis
	add	si,2
	mov	al,bh
	call	ascii_to_sjis
	add	si,2
	mov	al,bl
	call	ascii_to_sjis	

	mov	al,30h
	mov	ah,20h
	cmp	[MHz3],al
	jne	Print3
	mov	[MHz3],ah
	cmp	[MHz3+1],al
	jne	Print3
	mov	[MHz3+1],ah
	cmp	[MHz3+2],al
	jne	Print3
	mov	[MHz3+2],ah
	cmp	[MHz3+3],al
	jne	Print3
	mov	[MHz3+3],ah
	cmp	[MHz3+4],al
	jne	Print3
	mov	[MHz3+4],ah
Print3:
	mov	dx,CPU586
	mov	ah,9
	int	21h
	mov	dx,print3
	mov	ah,9
	int	21h
	mov	ah,4ch
	int	21h

CPU 386
timer8253:
	mov	ecx,[c16]
	mov	edi,[C16]
	cmp	ecx,edi
	ja	oktimer
	add	ecx,10000h
oktimer:
	sub	ecx,edi	;経過カウント数 5MHz系 2457600Hz 8MHz系 1996800Hz
				;0.406901us=407ns		0.500801us=501ns	100ms分のカウントのはず 26msしか測れないのに!
				;
				;割り算をすると407ns(501ns)あたりのCPUクロック
	div	ecx		;MHz(1usあたりのクロック)になおしたいから
				;->clock per 1count

	mov	ecx,24576	;clock per 1count * 24576count per 100ms -> 24576 clock per 100ms
	push	ax
	mov	dx,42h
	in	al,dx
	cmp	al,0xff
	je	system5_	;IOで確認できるならそうする できないような機種は10MHz系と決め付けてよい?
	test	al,0x20
	je	system5_	;立ってたら8MHz系
	mov	ecx,19968	;
system5_:
	pop	ax		;bug	つけ忘れ
	mul	ecx		;
	mov	ecx,100	;clock per 10ms / 100 -> clock per 1us =MHz
	div	ecx
	push	cs
	pop	ds
	jmp	calculate

		
end:
	pop	ax
	popf
	mov	ah,4ch
	int	21h

C64	dd	0
	dd	0
c64	dd	0
	dd	0
C24	dd	0
c24	dd	0
C16	dd	0
c16	dd	0
MHz	dd	0

	
print	db	'clock is '
MHz2	dw	2020h
	dw	2000h
	db	'.'
	dw	0
	db	' MHz?',0xd,0xa,'$'

print3	db	'clock is '
MHz3	dw	2020h
	dw	0
	dw	0
	db	' MHz?',0xd,0xa,'$'

alreadyused	db	'i8253 timer has been used by anything',0xd,0xa,
		db	'this program cannot calculate CPU frequency',0xd,0xa,'$'

CPU8086 db	'8086 ','$'
CPUV30	db	'V30 ','$'
CPU286	db	'80286 ','$'
CPU386	db	'i386 ','$'
CPU486	db	'i486 ','$'
CPUCyrix db	'Cyrix 5x86? ','$'
CPU586	db	'CPU with TSC and CPUID ','$'
CPUfamily:	db	0
timerNG:	db	0

loopnumber3	equ	500

CPU 386
withartic:
	cli
	call	artic
	mov	[c24],eax
	mov	cx,loopnumber3
	call	LAHFcount
	call	artic
	mov	[C24],eax

	mov	[c64],eax
	mov	cx,loopnumber3
	call	NOPcount
	call	artic
	mov	[C64],eax
	sti

	mov	eax,40		;3-2clock 40回		286と386はこれでいい 486はまた後で考える
	mov	ecx,loopnumber3	;loop 500回	これくらいやらないと差分がでない 20000回
	mul	ecx		;
	push	eax

	mov	edi,[c24]
	mov	ecx,[C24]
	cmp	ecx,edi
	ja	nocarry1
	add	ecx,1000000h
nocarry1:
	sub	ecx,edi	;LAHFの経過時間カウント 307.2kHz(3.26us)


	mov	edi,[c64]
	mov	eax,[C64]
	cmp	eax,edi
	ja	nocarry2
	add	ecx,1000000h
nocarry2:
	sub	eax,edi	;NOPの経過時間カウント 307.2kHz(3.26us)
	cmp	eax,ecx	;NOPがLAHFより遅いと386
	ja	sabun
	xchg	eax,ecx
	or	byte [CS:CPUfamily],4	;ついでに486と判明する
	push	eax
	push	ecx
	call	cyrixcheck
	pop	ecx
	pop	eax
	jc	sabun		;cyrixだったら下のことをしない
	shr	eax,1
	shr	ecx,1	;経過時間の方なので半減させる
sabun:
	sub	eax,ecx	;消えてた
	mov	ecx,307256	;307256hzのカウントで均してから
	mul	ecx
	mov	ecx,100000	;10万で割る
	div	ecx		;マイクロ秒に変換
	mov	ecx,eax

	pop	eax
	push	ecx
	mov	ecx,100
	mul	ecx		;100倍

	pop	ecx
	xor	edx,edx
	div	ecx		;これでいい?

	xor	edx,edx	;後で割り算されるので余りは消しておく
	jmp	under16



artic:;;return 24bit counter number to EAX
	mov	dx,5ch
	in	ax,dx
	push	ax
	mov	dx,5eh
	in	ax,dx
	pop	bx
	cmp	bh,al		;2度読みの間に833usは経過していないと思うけれども… 3マイクロ秒で繰り上がる可能性はある?
	je	ok
;	dec	ah		;繰り上がりを拒否 bug
	dec	ax
ok:
	shl	eax,8
	mov	ax,bx
	and	eax,00ffffffh	;24bit化
	ret


articwait:
	mov	ecx,132h	;306×3.26us=997.56us=1ms
	mul	ecx
	mov	ecx,eax
	call	artic
	add	ecx,eax
	test	ecx,0ff000000h
	jne	over
wait1:
	call	artic
	cmp	eax,ecx
	jb	wait1
	ret
over:	and	ecx,00ffffffh	;24bit値に変えて
	mov	edx,eax	;edxに避けて
wait2	call	artic
	cmp	eax,edx
	ja	wait2		;回ってなかったらまだ
	cmp	eax,ecx	;回ってたら差分取って
	jb	wait2		;wait
	ret

nocpuid:
	popfd
	jmp	calc286

CPU 8086

pitready:
	test	byte [cs:timerNG],1
	jne	noready
	mov	dx,77h
;;	mov	al,50h		;bug!!!! ch1 モード0 ???? LSBしか読まない
;;	mov	al,34h		;ch0 モード2! LSB,MSB両方読む 奇数でやるとややこい
	mov	al,30h		;ch0 モード0 LSB,MSB両方読みかき 割り込みはかかるが気にしないことにする
	out	dx,al
	mov	dx,71h
	mov	al,0feh	;偶数にする
	out	dx,al		;fefe回のカウンタで測ってみる
	out	dx,al
noready:
	ret
pitcount:
;;	test	byte [cs:timerNG],1
;;	jne	notready
;;	mov	dx,77h
;;	mov	al,50h		;bug!!!! ch1 モード0 ???? LSBしか読まない
;;	mov	al,34h
;;	out	dx,al		;ここで叩くとカウンタが止まるしなんかおかしくなる 
;;notready:			;割り込み禁止してるからチャンネル変わることはない! と想定してみよう
	mov	dx,71h
	in	al,dx		;LSB
	mov	ah,al
	in	al,dx		;MSB
	xchg	al,ah		
	ret

loopnumber	equ	1000
loopnumber2	equ	100
align 2
TRANScount:
	out	0e7h,ax	;0e7h 0e7h
	out	0e7h,ax	;0e7h V30 TRANS 9clock
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
;10
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
;20
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
;30
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
	out	0e7h,ax
;40
	loop	TRANScount	;8086 3	V30 2		286 8+		386 9+		486 1
	ret			;8086 16	V30 15cycle 	286 11cycle 	386 10cycle 	486 5cycle


align 2
LAHFcount:
	LAHF			;8086 4	V30 -386 2		486 3
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
;10
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
;20
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
;30
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
	LAHF
;40
	loop	LAHFcount	;8086 3	V30 2		286 8+		386 9+		486 1
	ret			;8086 16	V30 15cycle 	286 11cycle 	386 10cycle 	486 5cycle

align 2
NOPcount:
	NOP			;8086 -386 3		486 1
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
;10
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
;20
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
;30
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
;40
	loop	NOPcount	;8086 3	V30 2		286 8+		386 9+		486 1
	ret			;8086 16	V30 15cycle 	286 11cycle 	386 10cycle 	486 5cycle


timerusing:
	mov	dx,alreadyused
	mov	ah,9
	int	21h
	mov	ah,4ch
	int	21h

calc286:
	pop	ax
	popf

	or	byte [cs:CPUfamily],1	;over 286

	in	ax,5ch
	mov	dx,ax
	in	ax,5eh
	cmp	ax,-1
	jne	withartic
	cmp	dx,-1
	je	noartic
	cmp	al,dh
	je	withartic
noartic:
	mov	dx,2
	in	al,dx
	test	al,1		;IR0割り込みを許可中かの確認
	je	timerusing	;bit0が立ってなかったら誰かが使ってる その場合は中止

	cli			;割り込み禁止しなきゃ
	mov	si,MHz3
	call	pitready
	call	pitcount
	mov	[c16],ax
	mov	cx,loopnumber
	call	LAHFcount	;この間に65535カウントすすまれても困るわけじゃん!
	call	pitcount
	mov	[C16],ax

	call	pitready
	call	pitcount
	mov	[c64],ax
	mov	cx,loopnumber
	call	NOPcount
	call	pitcount
	mov	[C64],ax
	sti

;先に掛け算をする
	mov	ax,40		;3-2clock 40回		286と386はこれでいい 486はまた後で考える
	mov	cx,loopnumber	;loop 1000回
	mul	cx		;結果が65535以下になるようには調整 40000

	jmp	calc386

calcv30:
	pop	ax
	popf
	mov	byte [cs:CPUfamily],0

	mov	dx,2
	in	al,dx
	test	al,1		;IR0割り込みを許可中かの確認
	je	timerusing

	cli			;割り込み禁止しなきゃ
	mov	si,MHz3
	call	pitready
	call	pitcount
	mov	[c16],ax
	mov	cx,loopnumber2
	call	LAHFcount
	call	pitcount
	mov	[C16],ax

	call	pitready
	call	pitcount
	mov	[c24],ax
	mov	cx,loopnumber2
	call	TRANScount		;V30独自命令
	call	pitcount		;x86だと out e7h e7hに解釈される ここにくるのは8086の場合 初期98でそのIOには機能がないはず
	mov	[C24],ax


	call	pitready
	call	pitcount
	mov	[c64],ax
	mov	cx,loopnumber2
	call	NOPcount
	call	pitcount
	mov	[C64],ax

	sti
;先に掛け算をする
	mov	dx,[c16]
	mov	bx,[C16]
	sub	dx,bx		;counts for LAHF(2) and memory and etc. 8086の場合は4

	mov	ax,[c64]
	mov	bx,[C64]
	sub	ax,bx		;counts for NOP(3) and memory and etc. V30の場合はおそらく3ぴったりではない

	cmp	dx,ax
	ja	calc8086
;;V30の場合
	mov	ax,280		;9clock-2clock=7が40回
	mov	cx,loopnumber2;loop 100回		280*100=28000
	mul	cx		;結果がでかくなりすぎないようには調整 とりあえず 16bitで抑えよう

	push	ax

	mov	dx,[c16]
	mov	bx,[C16]
	sub	dx,bx		;counts for LAHF(2) and memory and etc.

	mov	ax,[c24]
	mov	bx,[C24]
	sub	ax,bx		;counts for TRANS(9) and memory and etc.

	sub	ax,dx
	jmp	calc_cont
calc8086:
	mov	ax,40		;4clock-3clockが40回
	mov	cx,loopnumber2;loop 100回		40*100=4000
	mul	cx		;結果がでかくなりすぎないようには調整 とりあえず 16bitで抑えよう
calc386:
	push	ax

	mov	dx,[c16]
	mov	bx,[C16]
	sub	dx,bx		;counts for LAHF(2) and memory and etc.

	mov	ax,[c64]
	mov	bx,[C64]
	sub	ax,bx		;counts for NOP(3) and memory and etc.

	cmp	ax,dx
	jb	calc_8086	;8086 NOP(3) LAHF(4)
	sub	ax,dx		;counts for only (NOP-LAHF) v30 NOP(3) - LAHF(2),INC(2)
				;差分の最大値は100倍しても65535にならない数値 655(28Fh)くらいまで許容
	jmp	calc_cont
calc_8086:
	or	byte [cs:CPUfamily],10h	;8086かもフラグ V30ではないフラグ
	sub	dx,ax
	xchg	ax,dx
	test	byte [cs:CPUfamily],2	;32bitCPUかの確かめ こっちに来てたら486
	je	calc_cont
	or	byte [CS:CPUfamily],4	;ついでに486と判明する
	push	ax
	call	cyrixcheck
	pop	ax
	jc	calc_cont
	shr	ax,1		;486の時は2倍 NOP(1) LAHF(3)  左に!シフトで2倍 ここは時間をはかってるから 1/2に再変更 でもCyrixなら不要
calc_cont:
	push	ax		;1FF2Cまでなら大丈夫 axだけならFFFFでも大丈夫
;;	mov	cx,24576
	mov	cx,4069	;1000000*100/24576
	mov	dx,42h
	in	al,dx
	cmp	al,0xff
	je	system5	;IOで確認できるならそうする できないような機種は10MHz系と決め付けてよい?
	test	al,0x20
	je	system5	;立ってたら8MHz系
;;	mov	cx,19968	;counts per 10ms
	mov	cx,5008	;1000000*100/19968 1カウントあたり500.8ns
system5:
	pop	ax		;かかったカウント数
	mul	cx		;掛け算して 0.1ナノ秒が何個あるかに変換 dx:axで32bit使える

	mov	cx,10000		;270F:D8F0までなら割れる
	div	cx		;マイクロ秒の単位になった
	mov	cx,ax		;経過時間をcxに一度よけて 0除算が発生してないということは65535以下であるはず

	pop	ax		;C8h(200) or 400
	push	cx
	mov	cx,100
	mul	cx		;表示上の問題で100倍して
	pop	cx
	div	cx		;クロック数を時間(マイクロ秒単位)で割る MHz*100の値で出てくる はず
	
	push	cs
	pop	ds
	call	hex_to_dec
	mov	si,MHz2
	call	ascii_to_sjis
	add	si,2
	mov	al,bh
	call	ascii_to_sjis
	add	si,3
	mov	al,bl
	call	ascii_to_sjis

	mov	al,30h
	mov	ah,20h
	cmp	[MHz2],al
	jne	Print4
	mov	[MHz2],ah
	cmp	[MHz2+1],al
	jne	Print4
	mov	[MHz2+1],ah
	cmp	[MHz2+2],al
	jne	Print4
	mov	[MHz2+2],ah
	cmp	[MHz2+3],al
	jne	Print4
	mov	[MHz2+3],ah
	cmp	[MHz2+4],al
	jne	Print4
	mov	[MHz2+4],ah
Print4:
	test	byte [CPUfamily],20h
	jne	Cyrix5x86
	test	byte [CPUfamily],8
	jne	TSCCPU
	test	byte [CPUfamily],4
	jne	squaredCPU
	test	byte [CPUfamily],2
	jne	dwordCPU
	test	byte [CPUfamily],1
	jne	Intel286	
	test	byte [CS:CPUfamily],10h
	jne	Intel8086
	mov	dx,CPUV30
Printcont:
	mov	ah,9
	int	21h
	mov	dx,print
	mov	ah,9
	int	21h
	mov	ah,4ch
	int	21h

Intel8086:
	mov	dx,CPU8086
	jmp	Printcont
Intel286:
	mov	dx,CPU286
	jmp	Printcont
dwordCPU:
	mov	dx,CPU386
	jmp	Printcont
squaredCPU:
	mov	dx,CPU486
	jmp	Printcont
TSCCPU:
	mov	dx,CPU586
	jmp	Printcont
Cyrix5x86:
	mov	dx,CPUCyrix
	jmp	Printcont


hex_to_dec:	;16進AX->10進数 1の位と10の位BL　100の位と1000の位BH　万の位AL
	xor	dx,dx
	mov	cx,10
	cmp	ax,10
	jb	hitoketa
	div	cx		;商がAX　あまりがDX
	mov	bl,dl		;BL=１の位
	xor	dx,dx
	cmp	ax,10
	jb	hutaketa
	div	cx
	mov	bh,dl		;BH=１０の位
	shl	bh,1
	shl	bh,1
	shl	bh,1
	shl	bh,1
	or	bl,bh		;BL完了
	xor	dx,dx
	cmp	ax,10
	jb	sanketa
	div	cl		;商がAL	　あまりが100の位AH
	mov	bh,ah
	xor	ah,ah
	cmp	ax,10
	jb	yonketa
	div	cl
	shl	ah,1		;1000の位
	shl	ah,1		;1000の位
	shl	ah,1		;1000の位
	shl	ah,1		;1000の位
	or	bh,ah
	xor	ah,ah
	ret
hitoketa:
	xor	bx,bx
	mov	bl,al
	xor	al,al
	ret
hutaketa:
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1
	or	bl,al
	xor	bh,bh
	xor	al,al
	ret
sanketa:
	mov	bh,al
	xor	al,al
	ret
yonketa:
	shl	al,1
	shl	al,1
	shl	al,1
	shl	al,1
	or	bh,al
	xor	al,al
	ret

ascii_to_sjis:		;ALの二文字（0-Fの16進数）をSIの中にシフトJISで4byteに
	push	es
	mov	dx,cs
	mov	es,dx
	mov	ah,al
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	cmp	al,9
	ja	A_F		;jb 10e
	OR	al,00110000b
	jmp	j		;jmp 114
A_F:
	dec	al
	and	al,7
	or	al,01000000b
j:	and	ah,0fh
	cmp	ah,9
	ja	A_F2		;jb 121
	OR	ah,00110000b
	jmp	j2		;jmp 129
A_F2:
	dec	ah
	and	ah,7
	or	ah,01000000b
j2:
;;;	mov	si,space300
	mov	[si],ax
	pop	es
	ret

CPU 486
cyrixcheck:
	pushfd
	mov	eax,0x5555
	xor	edx,edx
	mov	ecx,2
	clc
	div	ecx
	jnc	cyrix86	;何これ? だけれどもそうらしい 割り算をしたときにIntel486ではcarryが立つらしい
				;手持ちの486SXのNS/Aでは確かに立った 驚いた(5/6時点では) 11/4電源入らず再実験不可
	popfd			;5/8消えていたのを確認
	clc
	ret

cyrix86:
	popfd
	or	byte [CS:CPUfamily],20h
	stc
	ret
;;cyrixだと割り算で余りが出たときにcarryが立たないとのこと
;IBM486は立ってしまうとの報告をいただいた 感謝
;手元での確認
;Amd5x86(amd486の倍率4倍版)立つ
;MMXPentium 立つ
;Pentium3 coppermine 立たない

